// 005 u_gof_factory
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_gof_factory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    create_maze_: TButton;
    create_enchanted_maze_: TButton;
    create_bombed_maze_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_maze_Click(Sender: TObject);
    procedure create_enchanted_maze_Click(Sender: TObject);
    procedure create_bombed_maze_Click(Sender: TObject);
  private

  public

  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file

        , u_c_maze_3
        , u_c_maze_game_3

        , u_c_enchanted_room_and_door_3
        , u_c_enchanted_maze_game_3

        , u_c_bombed_room_and_wall_3
        , u_c_bombed_maze_game_3
    ;

    {$R *.DFM}

 
    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        // set_directory_listbox_directory(DirectoryListBox1, k_source_path);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_maze_Click(Sender: TObject);
      var l_c_maze: c_maze;
      begin
        with c_maze_game.create_maze_game do
        begin
          l_c_maze:= f_c_create_maze;
          // ...
        end; // with c_maze_game_
      end; // create_maze_Click

    procedure TForm1.create_enchanted_maze_Click(Sender: TObject);
      var l_c_maze: c_maze;
      begin
        with c_enchanted_maze_game.create_enchanted_maze_game do
        begin
          l_c_maze:= f_c_create_maze;
          // ...
        end; // with c_maze_game_
      end; // create_enchanted_maze_Click

    procedure TForm1.create_bombed_maze_Click(Sender: TObject);
      var l_c_maze: c_maze;
      begin
        with c_bombed_maze_game.create_bombed_maze_game do
        begin
          l_c_maze:= f_c_create_maze;
          // ...
        end; // with c_maze_game_
      end; // create_bombed_maze_Click

end.


