// 003 u_c_enchanted_room_and_door_3
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_enchanted_room_and_door_3;
  interface
    uses u_c_maze_3;

    type c_spell= Class
                    constructor create_spell;
                  end; // c_spell

         c_enchanted_room= Class(c_room)
                             m_c_spell: c_spell;

                             constructor create_enchanted_room(p_room_number: Integer;
                                 p_c_spell: c_spell);
                           end; // c_enchanted_room

         c_enchanted_door= Class(c_door)
                             m_c_spell: c_spell;

                             constructor create_enchanted_door(p_c_from_room, p_c_to_room: c_room;
                                 p_c_spell: c_spell);
                           end; // c_door

  implementation
    uses SysUtils, u_c_display;

    // -- c_spell

    constructor c_spell.create_spell;
      begin
        Inherited;
      end; // create_spell

    // -- c_enchanted_room

    constructor c_enchanted_room.create_enchanted_room(p_room_number: Integer;
        p_c_spell: c_spell);
      begin
        Inherited create_room(p_room_number);
        m_c_spell:= p_c_spell;
      end; // create_enchanted_room

    // -- c_enchanted_door

    constructor c_enchanted_door.create_enchanted_door(p_c_from_room, p_c_to_room: c_room;
        p_c_spell: c_spell);
      begin
        Inherited create_door(p_c_from_room, p_c_to_room);
        m_c_spell:= p_c_spell;
      end; // create_enchanted_door

  end. // u_c_enchanted_room


