// 003 u_c_maze_3
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_maze_3;
  interface

    type t_direction= (e_north, e_south, e_east, e_west);

         c_map_site= Class
                       constructor create_map_site;
                       procedure enter; Virtual; Abstract;
                     end; // c_map_site

         c_room= Class(c_map_site)
                   m_room_number: Integer;
                   m_side_array: array[t_direction] of c_map_site;

                   constructor create_room(p_room_number: Integer);
                   function f_c_get_side(p_direction: t_direction): c_map_site;
                   procedure set_side(p_direction: t_direction; p_c_side: c_map_site);
                   procedure enter; Override;
                 end; // c_room

         c_wall= Class(c_map_site)
                   constructor create_wall;
                   procedure enter; Override;
                 end; // c_wall

         c_door= Class(c_map_site)
                   m_c_from_room, m_c_to_room: c_room;
                   m_is_open: Boolean;

                   constructor create_door(p_c_from_room, p_c_to_room: c_room);
                   procedure enter; Override;
                   function f_c_other_side_from(p_c_room: c_room): c_room;
                 end; // c_door

         c_maze= Class
                   constructor create_maze;
                   procedure add_room(p_c_room: c_room);
                   function f_c_room(p_room_number: Integer): c_room;
                 end; // c_maze


  implementation
    uses SysUtils, u_c_display;

    // -- c_map_site

    constructor c_map_site.create_map_site;
      begin
      end; // create_map_site

    // -- c_room

    constructor c_room.create_room(p_room_number: Integer);
      begin
        Inherited Create;
        m_room_number:= p_room_number;
      end; // create_room

    function c_room.f_c_get_side(p_direction: t_direction): c_map_site;
      begin
        Result:= m_side_array[p_direction];
      end; // f_c_get_side

    procedure c_room.set_side(p_direction: t_direction; p_c_side: c_map_site);
      begin
        m_side_array[p_direction]:= p_c_side;
      end; // set_side

    procedure c_room.enter;
      begin
      end; // enter

    // -- c_wall

    constructor c_wall.create_wall;
      begin
      end; // create_wall

    procedure c_wall.enter;
      begin
      end; // enter

    // -- c_door

    constructor c_door.create_door(p_c_from_room, p_c_to_room: c_room);
      begin
        Inherited create_map_site;

        m_c_from_room:= p_c_from_room;
        m_c_to_room:= p_c_to_room;
      end; // create_door

    procedure c_door.enter;
      begin
      end; // enter

    function c_door.f_c_other_side_from(p_c_room: c_room): c_room;
      begin
        // -- avoid warnings
        Result:= Nil;
      end; // f_c_other_side_from

    // -- c_maze

    constructor c_maze.create_maze;
      begin
      end; // create_maze

    procedure c_maze.add_room(p_c_room: c_room);
      begin
      end; // add_room

    function c_maze.f_c_room(p_room_number: Integer): c_room;
      begin
        // -- avoid warnings
        Result:= Nil;
      end; // f_c_room

  end. // u_c_maze


